import numpy
from PyQt4 import QtCore, QtGui
Qt = QtCore.Qt

class NumpyModel(QtCore.QAbstractTableModel):
    def __init__(self, narray, parent=None):
        QtCore.QAbstractTableModel.__init__(self, parent)
        self._array = narray

    def rowCount(self, parent=None):
        return self._array.shape[0]

    def columnCount(self, parent=None):
        return self._array.shape[1]

    def data(self, index, role=Qt.DisplayRole):
        if index.isValid():
            if role == Qt.DisplayRole:
                row = index.row()
                col = index.column()
                return QtCore.QVariant("%.5f"%self._array[row, col])
        return QtCore.QVariant()

if __name__ == "__main__":
    a = QtGui.QApplication([])
    w = QtGui.QTableView()
    d = numpy.random.normal(0,1, (1000,1000))
    m = NumpyModel(d)
    w.setModel(m)

    w.show()
    a.exec_()
    
    
